<?php
/*
Plugin Name: Pixel Perfect
Plugin URI: http://www.musenuovo.co.uk
Description: Places image of your choice to overlay the site you are developing. You can hide it and bring it back to foreground at opacity you specify. Develope Wordpress sites faster and Pixel Perfect.
Version: 1.1
Author: Michal Balazi
Author URI: http://www.musenuovo.co.uk
License: GPL2
*/

/*  Copyright 2012  Michal Balazi  (email : michal_balazi@yahoo.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function is_login_page() {
    return in_array($GLOBALS['pagenow'], array('wp-login.php', 'wp-register.php'));
}


// Check if admin menu
if ( is_admin() || is_login_page() ) {

function pxp_admin_register_styles() {
add_action( 'pxp_styles', 'enqueue_my_styles' );
wp_enqueue_style( 'pxp_styles', '/wp-content/plugins/pixel-perfect/css/pixel-perfect-admin.css');
}
add_action('admin_head', 'pxp_admin_register_styles');

function pxp_option_page() {
// check form submission



// display the option page
?>
<div class="wrap">
<?php screen_icon(); ?>
<h2>Pixel Perfect Options</h2>
<p class="description">Welcome to Pixel Perfect plugin options menu. Upload image you want to overlay the page you are working on with design image to achieve pixel perfect layout when coding. You can specify opacity of the overlay, specify visible height of the overlay and specify which page the overlay should appear on.</p>

<form action="options.php" method="post" enctype="multipart/form-data" id="pxp_options_form">
<?php settings_fields('pxp_options');  ?>
<ul>


<li>
<label for="pxp_active">Active</label>
<input type="checkbox" id="pxp_active" name="pxp_active" value="Y" <?php if(get_option('pxp_active')=='Y') {echo'checked="checked"';} ?> /><span>Check to activate</span>
</li>

<li>
<label for="pxp_height">Overlay Height</label>
<input type="text" id="pxp_height" name="pxp_height" value="<?php echo get_option('pxp_height'); ?>" />
<span>px</span>
</li>

<li>
<label for="pxp_opacity">Opacity</label>
<input type="text" id="pxp_opacity" name="pxp_opacity" value="<?php echo get_option('pxp_opacity'); ?>" />
<span>1 = 100% opacity, 0.3 = 30% opacity</span>
</li>



<li>
<label for="pxp_topspacing">Admin Panel Spacing</label>
<input type="checkbox" id="pxp_topspacing" name="pxp_topspacing" value="1" <?php if(get_option('pxp_topspacing')==1) {echo'checked="checked"';} ?> />
<span>Check to add 28px top margin and move image under Wordpress admin panel</span>
</li>


<li>
<label for="pxp_page">Display on Page</label>
<select name="pxp_page" id="pxp_page"> 
 <?php 
  $pages = get_pages(); 
  foreach ( $pages as $page ) {
  if($page->ID == get_option('pxp_page')) {  	$option = '<option value="' . $page->ID . '" selected="selected">';} 
  else {  	$option = '<option value="' . $page->ID . '">'; }
	$option .= $page->post_title;
	$option .= '</option>';
	echo $option;
  }
 ?>
 

</select>
<span>Select which page to display the overlay on.</span>
</li>




<li>
<?php $image = get_option('pxp_image'); if($image['pxp_image']==''){ ?>

<label for="pxp_image">Overlay Image</label>
<input type="file" id="pxp_image" name="pxp_image" />

<?php } else { 

$image = get_option('pxp_image'); echo '<img src="' .$image['pxp_image'] . '" alt="" width="200" />';  
?>


<input type="submit" name="pxp_delete" value="Delete Image" class="button-secondary" id="pxp_delete" />


<?php } ?>
</li>


<li>
<input type="submit" name="submit" value="Save Options" class="button-primary" />
</li>
</ul>
</form>






</div>

<?php
}


function validate_setting($plugin_options) {
$keys = array_keys($_FILES); $i = 0; foreach ( $_FILES as $image ) {   
// if a files was upload   
if ($image['size']) {     
// if it is an image
if ( preg_match('/(jpg|jpeg|png|gif)$/', $image['type']) ) {       $override = array('test_form' => false);       
// save the file, and store an array, containing its location in $file
$file = wp_handle_upload( $image, $override );       
$plugin_options[$keys[$i]] = $file['url'];     
} else {       
// Not an image.        
$options = get_option('pxp_options');       
$plugin_options[$keys[$i]] = $options[$logo];       
// Die and let the user know that they made a mistake.
wp_die('No image was uploaded.');     
}   
}   
// Else, the user didn't upload a file.   // Retain the image that's already on file.   

else {     $options = get_option('pxp_options');     
$plugin_options[$keys[$i]] = $options[$keys[$i]];   }   $i++; } return $plugin_options;}

// register fields
function pxp_init(){
register_setting('pxp_options', 'pxp_active');
register_setting('pxp_options', 'pxp_height');
register_setting('pxp_options', 'pxp_opacity');
register_setting('pxp_options', 'pxp_topspacing');
register_setting('pxp_options', 'pxp_page');
$image = get_option('pxp_image'); if($image['pxp_image']=='' || isset($_POST['pxp_delete'])){ register_setting('pxp_options', 'pxp_image', 'validate_setting'); }
}

add_action('admin_init', 'pxp_init');

// create menu in the admin
function pxp_plugin_menu(){
add_options_page('Pixel Perfect Settings', 'Pixel Perfect', 'manage_options', 'pixel-perfect-plugin', 'pxp_option_page');
}

// add menu action
add_action('admin_menu', 'pxp_plugin_menu');

} else {
// Else display the overlay
if( get_option('pxp_active')=='Y'){



function pxp_image_overlay(){

if( is_page(get_option('pxp_page')) ) {

$image = get_option('pxp_image');
echo '<img src="' .$image['pxp_image']. '" id="pxp-image" height="'. get_option('pxp_height') .'" opacity="'. get_option('pxp_opacity') .'" topspacing="'. get_option('pxp_topspacing') .'" />';

add_action( 'pxp_java_script', 'enqueue_my_scripts' );
add_action( 'pxp_styles', 'enqueue_my_styles' );
wp_enqueue_style( 'pxp_styles', '/wp-content/plugins/pixel-perfect/css/pixel-perfect.css');
wp_enqueue_script( 'pxp_java_script', '/wp-content/plugins/pixel-perfect/js/pixel-perfect.js', array( 'jquery' ));

}

}

add_action( 'get_header' , 'pxp_image_overlay');






}

}



function pxp_activate() {

update_option( 'pxp_active', 'Y' );
update_option( 'pxp_height', '1200' );
update_option( 'pxp_opacity', '0.3' );
update_option( 'pxp_topspacing', '1' );
update_option('pxp_image', '');

}



register_activation_hook(__FILE__, 'pxp_activate' );




function pxp_uninstall() {

delete_option('pxp_active');
delete_option('pxp_height');
delete_option('pxp_opacity');
delete_option('pxp_topspacing');
delete_option('pxp_page');
delete_option('pxp_image');

}
 
register_uninstall_hook(__FILE__, 'pxp_uninstall');
 


?>